diff a/src/java.base/unix/classes/sun/nio/ch/UnixDispatcher.java b/src/java.base/unix/classes/sun/nio/ch/UnixDispatcher.java
--- a/src/java.base/unix/classes/sun/nio/ch/UnixDispatcher.java
+++ b/src/java.base/unix/classes/sun/nio/ch/UnixDispatcher.java
@@ -34,19 +34,19 @@
     @Override
     void close(FileDescriptor fd) throws IOException {
         close0(fd);
     }
 
-    private void signalThreads(long reader, long writer) {
+    private void signalThreads(NativeThread reader, NativeThread writer) {
         if (NativeThread.isNativeThread(reader))
-            NativeThread.signal(reader);
+            reader.signal();
         if (NativeThread.isNativeThread(writer))
-            NativeThread.signal(writer);
+            writer.signal();
     }
 
     @Override
-    void implPreClose(FileDescriptor fd, long reader, long writer) throws IOException {
+    void implPreClose(FileDescriptor fd, NativeThread reader, NativeThread writer) throws IOException {
         if (SUPPORTS_PENDING_SIGNALS) {
             signalThreads(reader, writer);
         }
         preClose0(fd);
         if (!SUPPORTS_PENDING_SIGNALS) {
